

//--podle BucCM_Master

#property copyright ""
#property link      ""

#define           GLOBAL_PREF             "_"       
#define           GLOBAL_TIMEPREF         "_"   

#define           OBJECT_PREF             "PROCENTA_"   
#define           CHAR_HEIGHT             7
#define           OBJECT_XDIFF            45

#property indicator_separate_window

#property indicator_buffers 8
#property indicator_color1 Red         
#property indicator_color2 Black       
#property indicator_color3 Blue        
#property indicator_color4 DarkGreen   
#property indicator_color5 Indigo      
#property indicator_color6 Orange      
#property indicator_color7 Magenta     
#property indicator_color8 Lime        

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
#property indicator_width8 1
  


extern string SYMBOL1 = "EURUSD";
extern string SYMBOL2 = "GBPUSD";
extern string SYMBOL3 = "USDJPY";
extern string SYMBOL4 = "USDCAD";
extern string SYMBOL5 = "EURJPY";
extern string SYMBOL6 = "GBPJPY";
extern string SYMBOL7 = "USDCHF";
extern string SYMBOL8 = "AUDUSD";

extern bool ShowAll = false;

extern int        LowHighBarsBack         = 0;             // pokud je to 0, bere se to od 0:00 - klasicky
extern int        LowHighBarsTimeFrame    = PERIOD_H1;
extern int        ShowHistoryBars         = 1000;

extern bool       SetGlobalVariable       = false;

double            TS_SYMBOL1, TS_SYMBOL2, TS_SYMBOL3, TS_SYMBOL4, TS_SYMBOL5, TS_SYMBOL6, TS_SYMBOL7, TS_SYMBOL8;
double             Opens[30],  Bids[30];

double            Buff_SYMBOL1[], Buff_SYMBOL2[], Buff_SYMBOL3[], Buff_SYMBOL4[], Buff_SYMBOL5[], Buff_SYMBOL6[], Buff_SYMBOL7[], Buff_SYMBOL8[];

int SS1,SS2,SS3,SS4, SS5,SS6,SS7,SS8;
 
 //--------
 
int init()
{

if (ShowAll == true)   {SYMBOL1 = "USD";SYMBOL2="EUR";SYMBOL3="GBP";SYMBOL4="CHF";SYMBOL5="CAD";SYMBOL6="AUD";SYMBOL7="JPY";SYMBOL8="NZD";}

	IndicatorBuffers(8);

   SetIndexStyle (0, DRAW_LINE);
   SetIndexBuffer(0, Buff_SYMBOL1);
   SetIndexLabel (0, SYMBOL1);

   SetIndexStyle (1, DRAW_LINE);
   SetIndexBuffer(1, Buff_SYMBOL2);
   SetIndexLabel (1, SYMBOL2);

   SetIndexStyle (2, DRAW_LINE);
   SetIndexBuffer(2, Buff_SYMBOL3);
   SetIndexLabel (2, SYMBOL3);

   SetIndexStyle (3, DRAW_LINE);
   SetIndexBuffer(3, Buff_SYMBOL4);
   SetIndexLabel (3, SYMBOL4);

   SetIndexStyle (4, DRAW_LINE);
   SetIndexBuffer(4, Buff_SYMBOL5);
   SetIndexLabel (4, SYMBOL5);

   SetIndexStyle (5, DRAW_LINE);
   SetIndexBuffer(5, Buff_SYMBOL6);
   SetIndexLabel (5, SYMBOL6);

   SetIndexStyle (6, DRAW_LINE);
   SetIndexBuffer(6, Buff_SYMBOL7);
   SetIndexLabel (6, SYMBOL7);

   SetIndexStyle (7, DRAW_LINE);
   SetIndexBuffer(7, Buff_SYMBOL8);
   SetIndexLabel (7, SYMBOL8);
   

   IndicatorShortName(GetIndicatorShortName());
   return(0);
}

string GetIndicatorShortName()
{
   return ("PROCENTA  ( " + LowHighBarsBack + "  ,  " + LowHighBarsTimeFrame + " )");
}

int deinit()
{
   
   
   
    ObjectsDeleteAll(); 
   
   return(0);
}

int start()
{
  int counted_bars = IndicatorCounted();
	int i, j, limit;
	
	//---- 
	  if(counted_bars < 0) 
	    { 
	      Print("Indicator Error (Counted bars < 0)!"); 
	      return(-1); 
	    }
  //----
	 
	for(i=Bars-counted_bars; i>=0; i--)
  {
   if (i>ShowHistoryBars) i=ShowHistoryBars;
   
   CurrencyMeter(i);   
         
   Buff_SYMBOL1[i] = TS_SYMBOL1; 
   Buff_SYMBOL2[i] = TS_SYMBOL2;
   Buff_SYMBOL3[i] = TS_SYMBOL3;
   Buff_SYMBOL4[i] = TS_SYMBOL4;
  Buff_SYMBOL5[i] = TS_SYMBOL5;
   Buff_SYMBOL6[i] = TS_SYMBOL6;
   Buff_SYMBOL7[i] = TS_SYMBOL7;
   Buff_SYMBOL8[i] = TS_SYMBOL8;
  }
  
   if (SetGlobalVariable)
   {
     GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + SYMBOL1+"  ", TS_SYMBOL1);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) +SYMBOL2+"  ", TS_SYMBOL2);
     GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + SYMBOL3+"  ", TS_SYMBOL3);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + SYMBOL4+"  ", TS_SYMBOL4);
     GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + SYMBOL5+"  ", TS_SYMBOL5);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + SYMBOL6+"  ", TS_SYMBOL6);
     GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + SYMBOL7+"  ", TS_SYMBOL7);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + SYMBOL8+"  ", TS_SYMBOL8);
      
      GlobalVariableSet(GLOBAL_TIMEPREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "Hour",     Hour());
      GlobalVariableSet(GLOBAL_TIMEPREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "Minute",   Minute());
      GlobalVariableSet(GLOBAL_TIMEPREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "Second",   Seconds());
      GlobalVariableSet(GLOBAL_TIMEPREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "DateTime", TimeCurrent());
   }
  
  ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + SYMBOL1+"  ",  1 + 0 * OBJECT_XDIFF, 1, SYMBOL1+"  "+ DoubleToStr(TS_SYMBOL1, 2), indicator_color1);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + SYMBOL2+"  ",  1 + 3 * OBJECT_XDIFF, 1, SYMBOL2+"  " + DoubleToStr(TS_SYMBOL2, 2), indicator_color2);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + SYMBOL3+"  ",  1 + 6 * OBJECT_XDIFF, 1, SYMBOL3 +"  "+ DoubleToStr(TS_SYMBOL3, 2), indicator_color3);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + SYMBOL4+"  ",  1 + 9 * OBJECT_XDIFF, 1, SYMBOL4+"  " + DoubleToStr(TS_SYMBOL4, 2), indicator_color4);
  ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + SYMBOL5+"  ",  1 + 12 * OBJECT_XDIFF, 1, SYMBOL5+"  " + DoubleToStr(TS_SYMBOL5, 2), indicator_color5);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + SYMBOL6+"  ",  1 + 15 * OBJECT_XDIFF, 1, SYMBOL6+"  "+ DoubleToStr(TS_SYMBOL6, 2), indicator_color6);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + SYMBOL7+"  ",  1 + 18 * OBJECT_XDIFF, 1, SYMBOL7+"  " + DoubleToStr(TS_SYMBOL7, 2), indicator_color7);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + SYMBOL8+"  ",  1 + 21 * OBJECT_XDIFF, 1, SYMBOL8+"  " + DoubleToStr(TS_SYMBOL8, 2), indicator_color8);
}

void ShowTextObject(string ObjName, int XPos, int YPos, string TextToShow, int TextColor)
{
   if (ObjectFind(ObjName) == -1)
   {
//      ObjectCreate (ObjName, OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0);
      ObjectCreate (ObjName, OBJ_LABEL, WindowFind(GetIndicatorShortName()), 0, 0);
      ObjectSet    (ObjName, OBJPROP_CORNER, 2);
      ObjectSet    (ObjName, OBJPROP_XDISTANCE, XPos);
      ObjectSet    (ObjName, OBJPROP_YDISTANCE, YPos);
   }
   ObjectSetText(ObjName, TextToShow, CHAR_HEIGHT, "Arial Bold", TextColor);
}

double GetBid(int CurIndex, int shift)
{
   if (shift==0)
    return (MarketInfo(GetCurrencyNameByIndex(CurIndex), MODE_BID));
   else
    return (iClose(GetCurrencyNameByIndex(CurIndex), Period(), shift));
}



double GetOpen(int CurIndex, int shift)
{
   if (LowHighBarsBack == 0)
      return (iOpen(GetCurrencyNameByIndex(CurIndex), 1440, shift/1440));
   else
   {
      double  CurCandleOpen;
      for (int i = 0; i < LowHighBarsBack; i++)
      {
         CurCandleOpen = iOpen(GetCurrencyNameByIndex(CurIndex), LowHighBarsTimeFrame, (shift/LowHighBarsTimeFrame)+i);
  
      }
      return (CurCandleOpen);
   }
}


string GetCurrencyNameByIndex(int Index)
{
   switch (Index)
   {
   case 1: return  ("EURUSD");
   case 2: return  ("GBPUSD");
   case 3: return  ("AUDUSD");
   case 4: return  ("USDJPY");
   case 5: return  ("USDCHF");
   case 6: return  ("USDCAD");
   case 7: return  ("EURJPY");
   case 8: return  ("EURGBP");
   case 9: return  ("EURCHF");
   case 10: return ("EURAUD");
   case 11: return ("GBPJPY");
   case 12: return ("GBPCHF");
   case 13: return ("EURCAD");
   case 14: return ("CHFJPY");
   case 15: return ("CADJPY");
   case 16: return ("CADCHF");
   case 17: return ("AUDCHF");
   case 18: return ("AUDCAD");
   case 19: return ("AUDJPY");
   case 20: return ("NZDUSD");
   case 21: return ("NZDCAD");
   case 22: return ("NZDCHF");
   case 23: return ("NZDJPY");
   case 24: return ("NZDGBP");
   case 25: return ("EURNZD");
   case 26: return ("GBPCAD");
   case 27: return ("GBPAUD");
   case 28: return ("AUDNZD");
   case 29: return ("GBPNZD");
   
   
   default: return ("");
   }
}

void Proc(int shift)
{
   for (int i = 1; i <= 29; i++)
   {
      
      Opens[i]     = GetOpen(i, shift);
     
      Bids[i]      = GetBid(i, shift);
   }
}


void CurrencyMeter(int shift)
{
   Proc(shift);
   
   double PROC[30];
   for (int i = 1; i <= 29; i++)
  
   {
     
         PROC[i]  = ((Bids[i] *100) /(Opens[i] ))- 100;
     
   }
   
   double RS13[30];
   double RS15[30];
    
   for (i = 1; i <= 29; i++)
   {
      RS13[i] =  PROC[i];
      RS15[i] = - RS13[i]; 
      
      
      if (SYMBOL1 == GetCurrencyNameByIndex(i)) SS1 = i;
      if (SYMBOL2 == GetCurrencyNameByIndex(i)) SS2 = i;  
      if (SYMBOL3 == GetCurrencyNameByIndex(i)) SS3 = i;
      if (SYMBOL4 == GetCurrencyNameByIndex(i)) SS4 = i;      
      if (SYMBOL5 == GetCurrencyNameByIndex(i)) SS5 = i;
      if (SYMBOL6 == GetCurrencyNameByIndex(i)) SS6 = i;  
      if (SYMBOL7 == GetCurrencyNameByIndex(i)) SS7 = i;
      if (SYMBOL8 == GetCurrencyNameByIndex(i)) SS8 = i;  
      
   }
    
    if (ShowAll == true) {
       
    
  TS_SYMBOL1 = (RS13[4]+RS13[5]+RS13[6]+RS15[1]+RS15[2]+RS15[3]+RS15[20])/7;
  TS_SYMBOL2 = (RS13[1]+RS13[7]+RS13[8]+RS13[9]+RS13[10]+RS13[13]+RS13[25])/7;
  TS_SYMBOL3 = (RS13[2]+RS13[11]+RS13[12]+RS13[26]+RS13[27]+RS15[8]+RS13[29])/7 ;
  TS_SYMBOL4 = (RS13[14]+RS15[5]+RS15[9]+RS15[12]+RS15[16]+RS15[17]+RS15[22])/7 ;
 TS_SYMBOL5 = (RS13[15]+RS13[16]+RS15[6]+RS15[13]+RS15[18]+RS15[21]+RS15[26])/7 ;
 TS_SYMBOL6 = (RS13[3]+RS13[17]+RS13[18]+RS13[19]+RS13[28]+RS15[10]+RS15[27])/7 ;
   TS_SYMBOL7 = (RS15[4]+RS15[7]+RS15[11]+RS15[14]+RS15[15]+RS15[19]+RS15[23])/7;
   TS_SYMBOL8 = (RS13[20]+RS13[21]+RS13[22]+RS13[23]+RS15[25]+RS15[28]+RS15[29])/7;
} 

if (ShowAll == false) {

  
      TS_SYMBOL1 = RS13[SS1]; 
        TS_SYMBOL2 = RS13[SS2]; 
   TS_SYMBOL3 = RS13[SS3]; 
  TS_SYMBOL4 = RS13[SS4]; 
  TS_SYMBOL5 = RS13[SS5]; 
    TS_SYMBOL6 =RS13[SS6]; 
   TS_SYMBOL7 = RS13[SS7]; 
   TS_SYMBOL8 = RS13[SS8]; 
} 

}   

